//=============================================================================
// Ez-RoboMaster Test Program - DX Motor Robot Arm Test
//
// by (jh.park@ezlab.com)
// [arm.c]
//=============================================================================

/*
 - DX-Motor ̿Ͽ κ  
 - Ez-RoboMaster AI MotorƮ DX-Motor(2° ) DX-͸ Ѵ.
 - Dx-Motor 3 ̿ ID 1~3 Ѵ.
 - ø Ʈ 'u', 'd', 's' ϸ κ øų   Ѵ.
 - ø Ʈ 'g' ϸ   ġ ǥѴ.
 - ǥõ ġ  ̿Ͽ ٸ  ߰  ִ.
*/

//Ez-RoboMaster API 
#include "c:\winavr\ezrobomaster\ezrmlib.h"
#include "dx_arm.h"

unsigned int m_PosUp[3] = {394, 2, 859};
unsigned int m_PosScan = {400, 544, 340};
unsigned int m_PosDown[3] = {561, 428, 254};
unsigned int m_PosCurrent[3];

//Arm ¸ ϴ Լ
void ArmStatus(unsigned char Status)
{
	switch(Status)
	{
		case ARM_STATUS_SCAN:
			//Arm ü  ġ ̵
			amr_MovePos(400, 544, 340);
			break;
					
		case ARM_STATUS_UP:
			//ü  ø ġ ̵
			arm_Move(m_PosUp);
			break;
			
		case ARM_STATUS_DOWN:
			//ü ų   ġ ̵
			arm_Move(m_PosScan);
			Delay(1500);
			arm_Move(m_PosDown);
			break;
			
		default :
			return ;
	}						
}

void DisPlayArmPos(void)
{
	unsigned int pos[3];
	
	//3 ġ ͼ
	arm_GetArmPos(pos);
	
	printf("M1=%d, M2=%d, M3=%d\r\n", pos[0], pos[1], pos[2]);
		
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//Main α׷
int main(void)
{
	unsigned char data = 0;
	
	//Ez-RoboMasterʱȭ
	SysInit();

	InitArm();
	
	LcdClr(LINE_ALL);
	LcdDspStr(0,0, "ArmTest ");
			
	while(1)
	{
		//̾ Ʈ Ͱ ۵Ǹ
		if(SrlKbhit())
		{
			data = SrlRcvByte();
			printf("\r\n");
			switch(data)
			{
				case 'u':
					printf("Arm Up\r\n");
					ArmStatus(ARM_STATUS_UP);
					break;
					
				case 'd':
					printf("Arm Down\r\n");
					ArmStatus(ARM_STATUS_UP);
					break;
					
				case 's':
					printf("Arm Scan\r\n");
					ArmStatus(ARM_STATUS_SCAN);
					break;					
					
				case 'g':
					DisPlayArmPos();
					break;
			}
			
			printf("Press [u], [d], [g], key>");
			Delay(100);
		}		

	}
	
	return 1;
}
//-----------------------------------------------------------------------------